Attribute VB_Name = "Module3"
Option Explicit

Public Type SAFEARRAYBOUND
  cElements As Long
  lLbound As Long
End Type

Public Type SAFEARRAY
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  Bounds(0 To 1) As SAFEARRAYBOUND
End Type

Public Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Public IMAGEWIDTH As Long
Public IMAGEHEIGHT As Long

Public Bmp As BITMAP

Public ImageBuffer() As Byte
Public FrameBuffer() As Byte
Public BackGround() As Byte

Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Public Sub Init(PB As PictureBox, Optional Width As Long, Optional Height As Long)

Dim i As Long
Dim FileName As String
Dim SA As SAFEARRAY
Dim Offset As Long

If Width = 0 Then Width = PB.ScaleWidth
If Height = 0 Then Height = PB.ScaleHeight

FileName = MakeBitmap(Width, Height)
PB.Picture = LoadPicture(FileName)
Kill FileName

Call GetObject(PB.Picture, Len(Bmp), Bmp)

IMAGEWIDTH = Bmp.bmWidth
IMAGEHEIGHT = Bmp.bmHeight

Form1.Picture1.Appearance = 0
Form1.Picture1.BorderStyle = vbBSNone
Form1.Picture1.Width = IMAGEWIDTH * Screen.TwipsPerPixelX
Form1.Picture1.Height = IMAGEHEIGHT * Screen.TwipsPerPixelY
Form1.Picture1.ScaleMode = vbPixels

With SA
    .cbElements = 1
    .cDims = 1
    .Bounds(0).lLbound = 0
    .Bounds(0).cElements = Bmp.bmWidthBytes * Bmp.bmHeight
    .pvData = Bmp.bmBits
End With

Call CopyMemory(ByVal VarPtrArray(ImageBuffer), VarPtr(SA), 4)

For Offset = 0 To UBound(ImageBuffer) Step 3
    ImageBuffer(Offset) = 240
    ImageBuffer(Offset + 1) = 240
    ImageBuffer(Offset + 2) = 240
Next

ReDim BackGround(0 To UBound(ImageBuffer)) As Byte
Call CopyMemory(BackGround(0), ImageBuffer(0), UBound(ImageBuffer) + 1)
FrameBuffer = BackGround

PB.Refresh
Call CopyMemory(ByVal VarPtrArray(ImageBuffer), 0&, 4)

End Sub

