VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7155
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   16410
   LinkTopic       =   "Form1"
   ScaleHeight     =   7155
   ScaleWidth      =   16410
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox Check1 
      Caption         =   "Bilinear"
      Height          =   195
      Left            =   7200
      TabIndex        =   4
      Top             =   6120
      Width           =   1035
   End
   Begin VB.PictureBox Picture2 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000018&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   6660
      Left            =   9540
      MousePointer    =   2  'Kreuz
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   444
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   444
      TabIndex        =   2
      Top             =   240
      Width           =   6660
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Exit"
      Height          =   495
      Left            =   6960
      TabIndex        =   1
      Top             =   6420
      Width           =   2475
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  '2D
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   6660
      Left            =   240
      MousePointer    =   2  'Kreuz
      ScaleHeight     =   444
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   444
      TabIndex        =   0
      Top             =   240
      Width           =   6660
   End
   Begin VB.Label Label1 
      Height          =   3915
      Left            =   7020
      TabIndex        =   3
      Top             =   360
      Width           =   2355
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim BaseX As Single
Dim BaseY As Single
Dim RotPoint As Point2D
Dim RotAngle As Long

Private Sub Check1_Click()

Call DrawPoly(OnePoly, RawPoly)

End Sub

Private Sub Command2_Click()

Unload Me

End Sub

Private Sub PrepareTexture()

OnePoly.Vertex(0).X = 50
OnePoly.Vertex(0).Y = 50
OnePoly.Vertex(1).X = 350
OnePoly.Vertex(1).Y = 260
OnePoly.Vertex(2).X = 280
OnePoly.Vertex(2).Y = 100

Call LoadTexture

Form1.Picture2.Line (OnePoly.Vertex(0).X, OnePoly.Vertex(0).Y)-(OnePoly.Vertex(1).X, OnePoly.Vertex(1).Y)
Form1.Picture2.Line (OnePoly.Vertex(1).X, OnePoly.Vertex(1).Y)-(OnePoly.Vertex(2).X, OnePoly.Vertex(2).Y)
Form1.Picture2.Line (OnePoly.Vertex(2).X, OnePoly.Vertex(2).Y)-(OnePoly.Vertex(0).X, OnePoly.Vertex(0).Y)

Form1.Refresh
DoEvents

End Sub

Private Sub Form_Load()

Form1.MousePointer = vbHourglass

RotPoint.X = Form1.Picture1.ScaleWidth \ 2
RotPoint.Y = Form1.Picture1.ScaleHeight \ 2

Call Init(Form1.Picture1)
Call PrepareTexture
RawPoly = OnePoly

Form1.Label1 = "Rechts:" & vbNewLine & "Quelle. Die Eckpunkte des Dreiecks beliebig ziehen." & vbNewLine & vbNewLine & "Links:" & vbNewLine & "Ziel. Die Eckpunkte des Dreiecks beliebig ziehen (linke Maustaste)." & vbNewLine & "Rechte Maustaste + rechts/links verschieben dreht das Dreieck." & vbNewLine & "Per Doppelklick (linke Maustaste) einen neuen Rotationspunkt festlegen."

If Not IsEXE Then Form1.Caption = Form1.Caption & " - Compile me for optimal speed."

Call DrawPoly(OnePoly, RawPoly)

Form1.MousePointer = vbDefault

End Sub

Private Sub Picture1_DblClick()

RotPoint.X = BaseX
RotPoint.Y = BaseY

End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

BaseX = X

End Sub

Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim Dist0 As Single
Dim Dist1 As Single
Dim Dist2 As Single
Dim WhichPoint As Long

Dim DiffX As Single

If Button = 1 Then
    Dist0 = ((X - OnePoly.Vertex(0).X) ^ 2) + ((Y - OnePoly.Vertex(0).Y) ^ 2)
    Dist1 = ((X - OnePoly.Vertex(1).X) ^ 2) + ((Y - OnePoly.Vertex(1).Y) ^ 2)
    Dist2 = ((X - OnePoly.Vertex(2).X) ^ 2) + ((Y - OnePoly.Vertex(2).Y) ^ 2)
    
    If Dist0 < Dist1 And Dist0 < Dist2 Then WhichPoint = 0
    If Dist1 < Dist0 And Dist1 < Dist2 Then WhichPoint = 1
    If Dist2 < Dist0 And Dist2 < Dist1 Then WhichPoint = 2
    
    OnePoly.Vertex(WhichPoint).X = X
    OnePoly.Vertex(WhichPoint).Y = Y
    Call DrawPoly(OnePoly, RawPoly)
End If

If Button = 2 Then
    DiffX = X - BaseX
    RotAngle = RotAngle + DiffX
    
    If RotAngle >= 360 Then
        RotAngle = RotAngle - 360
        BaseX = X
    End If
    
    If RotAngle < 0 Then
        RotAngle = 360 - Abs(RotAngle)
        BaseX = X
    End If
    
    OnePoly = RotatePoly(OnePoly, RotPoint, RotAngle)
    Call DrawPoly(OnePoly, RawPoly)
    
    RotAngle = 0
    BaseX = X
End If

End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

BaseX = X
BaseY = Y

End Sub

Private Sub Picture2_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim Dist0 As Single
Dim Dist1 As Single
Dim Dist2 As Single
Dim WhichPoint As Long

If X <= 0 Then Exit Sub
If Y <= 0 Then Exit Sub
If X >= IMAGEWIDTH - 1 Then Exit Sub
If Y >= IMAGEHEIGHT - 1 Then Exit Sub

If Button = 1 Then
    Dist0 = ((X - RawPoly.Vertex(0).X) ^ 2) + ((Y - RawPoly.Vertex(0).Y) ^ 2)
    Dist1 = ((X - RawPoly.Vertex(1).X) ^ 2) + ((Y - RawPoly.Vertex(1).Y) ^ 2)
    Dist2 = ((X - RawPoly.Vertex(2).X) ^ 2) + ((Y - RawPoly.Vertex(2).Y) ^ 2)
    
    If Dist0 < Dist1 And Dist0 < Dist2 Then WhichPoint = 0
    If Dist1 < Dist0 And Dist1 < Dist2 Then WhichPoint = 1
    If Dist2 < Dist0 And Dist2 < Dist1 Then WhichPoint = 2
    
    RawPoly.Vertex(WhichPoint).X = X
    RawPoly.Vertex(WhichPoint).Y = Y
    
    Form1.Picture2.Cls
    Form1.Picture2.Line (RawPoly.Vertex(0).X, RawPoly.Vertex(0).Y)-(RawPoly.Vertex(1).X, RawPoly.Vertex(1).Y)
    Form1.Picture2.Line (RawPoly.Vertex(1).X, RawPoly.Vertex(1).Y)-(RawPoly.Vertex(2).X, RawPoly.Vertex(2).Y)
    Form1.Picture2.Line (RawPoly.Vertex(2).X, RawPoly.Vertex(2).Y)-(RawPoly.Vertex(0).X, RawPoly.Vertex(0).Y)
    Form1.Picture2.Refresh
    DoEvents
    
    OnePoly = RawPoly
    
    Call DrawPoly(OnePoly, RawPoly)
End If

End Sub

Private Function IsEXE() As Boolean

Static bEXE As Boolean

If Not bEXE Then
    bEXE = True
    Debug.Assert IsEXE() Or True
    IsEXE = bEXE
End If

bEXE = False

End Function

